zoukankan      html  css  js  c++  java
  • Codeforces Round #191 (Div. 2) D. Block Tower

    D. Block Tower
    time limit per test
    2 seconds
    memory limit per test
    256 megabytes
    input
    standard input
    output
    standard output

    After too much playing on paper, Iahub has switched to computer games. The game he plays is called "Block Towers". It is played in a rectangular grid with n rows and m columns (it contains n × m cells). The goal of the game is to build your own city. Some cells in the grid are big holes, where Iahub can't build any building. The rest of cells are empty. In some empty cell Iahub can build exactly one tower of two following types:

    1. Blue towers. Each has population limit equal to 100.
    2. Red towers. Each has population limit equal to 200. However, it can be built in some cell only if in that moment at least one of the neighbouring cells has a Blue Tower. Two cells are neighbours is they share a side.

    Iahub is also allowed to destroy a building from any cell. He can do this operation as much as he wants. After destroying a building, the other buildings are not influenced, and the destroyed cell becomes empty (so Iahub can build a tower in this cell if needed, see the second example for such a case).

    Iahub can convince as many population as he wants to come into his city. So he needs to configure his city to allow maximum population possible. Therefore he should find a sequence of operations that builds the city in an optimal way, so that total population limit is as large as possible.

    He says he's the best at this game, but he doesn't have the optimal solution. Write a program that calculates the optimal one, to show him that he's not as good as he thinks.

    Input

    The first line of the input contains two integers n and m (1 ≤ n, m ≤ 500). Each of the next n lines contains m characters, describing the grid. The j-th character in the i-th line is '.' if you're allowed to build at the cell with coordinates (i, j) a tower (empty cell) or '#' if there is a big hole there.

    Output

    Print an integer k in the first line (0 ≤ k ≤ 106) — the number of operations Iahub should perform to obtain optimal result.

    Each of the following k lines must contain a single operation in the following format:

    1. «B x y» (1 ≤ x ≤ n, 1 ≤ y ≤ m) — building a blue tower at the cell (x, y);
    2. «R x y» (1 ≤ x ≤ n, 1 ≤ y ≤ m) — building a red tower at the cell (x, y);
    3. «D x y» (1 ≤ x ≤ n, 1 ≤ y ≤ m) — destroying a tower at the cell (x, y).

    If there are multiple solutions you can output any of them. Note, that you shouldn't minimize the number of operations.

    Sample test(s)
    input
    2 3
    ..#
    .#.
    
    output
    4
    B 1 1
    R 1 2
    R 2 1
    B 2 3
    
    input
    1 3
    ...
    
    output
    5
    B 1 1
    B 1 2
    R 1 3
    D 1 2
    R 1 2
    



    在 ' . ' 上建造房子,蓝色容纳100人。红色容纳200人,在106      步数以内建造尽可能大的容纳量,可是在建造红色房子时,与它相邻的必须有蓝色房子。



    思路:先将全部建成蓝色。图最大是500*500,假设三种步骤都进行是3*500*500,不会超过106    题目并没有要求步骤尽量少。仅仅须要满足容纳量尽量多就可以,所以



    所有建成蓝色后。再从边界開始改建成红色,因此DFS就可以完毕。





    #include <iostream>
    #include <stdio.h>
    #include <string>
    #include <cstring>
    #include <cmath>
    #include <algorithm>
    #include <queue>
    #define N 600
    using namespace std;
    
    char s[N][N];
    int vis[N][N];
    
    struct Node
    {
        char a;
        int x,y;
    }f[1000009];
    
    int n,m;
    int num;
    
    int fun(char c,int x,int y)
    {
        s[x][y]=c;
        num++;
        f[num].a=c;
        f[num].x=x;
        f[num].y=y;
    
    }
    
    void dfs(int x,int y)
    {
        if(s[x][y]!='B' || vis[x][y] ) return;//假设是'#'或者已经被改造
    
        vis[x][y]=1;
    
        if(y>1) dfs(x,y-1);
        if(x>1) dfs(x-1,y);
        if(y<m) dfs(x,y+1);
        if(x<n) dfs(x+1,y);
    
        fun('D',x,y);
        fun('R',x,y);
        return;
    }
    
    int main()
    {
        while(~scanf("%d%d",&n,&m))
        {
            for(int i=1;i<=n;i++)
            scanf("%s",s[i]+1);
    
            memset(vis,0,sizeof vis);
            num=0;
    
            for(int i=1;i<=n;i++)//先所有建成’B'
            for(int j=1;j<=m;j++)
            {
                if(s[i][j]=='.')
                fun('B',i,j);
            }
    
            for(int i=1;i<=n;i++)
            {
                for(int j=1;j<=m;j++)
                if(s[i][j]=='B')
                {
                    vis[i][j]=1;
    
                    if(j>1) dfs(i,j-1);
                    if(i>1) dfs(i-1,j);
                    if(j<m) dfs(i,j+1);
                    if(i<n) dfs(i+1,j);
    
                }
            }
    
            printf("%d
    ",num);
            for(int i=1;i<=num;i++)
            {
                printf("%c %d %d
    ",f[i].a,f[i].x,f[i].y);
            }
    
        }
        return 0;
    }
    












  • 相关阅读:
    MySQL复制延时排查
    SQL优化之【类型转换】
    Twemproxy 介绍与使用
    Redis Cluster 3.0搭建与使用
    unauthenticated user reading from net
    XtraBackup之踩过的坑
    Redis学习之实现优先级消息队列
    如何保证接口的幂等性
    Redis缓存网页及数据行
    Rabbitmq 消费者的推模式与拉模式(go语言版本)
  • 原文地址:https://www.cnblogs.com/mengfanrong/p/5134908.html
Copyright © 2011-2022 走看看